码迷,mamicode.com
首页 > 其他好文 > 详细

<LeetCode>双指针题目·

时间:2019-09-17 11:04:42      阅读:87      评论:0      收藏:0      [点我收藏+]

标签:ret   remove   统一   nod   class   使用   The   inpu   null   

1.82. Remove Duplicates from Sorted List II (Medium)

Given a sorted linked list, delete all nodes that have duplicate numbers, leaving only distinct numbers from the original list.

Example 1:
Input: 1->2->3->3->4->4->5
Output: 1->2->5

Example 2:
Input: 1->1->1->2->3
Output: 2->3

题目分析:

  1. Example 1中,要将重复的3全部删除,可以使用一个指针slow指向2,另外一个指针fast指向3,让2的next指向3的next
  2. 在Example 2中,看到需要删除的可能是头节点,因此需要一个dummy节点指向头节点,这样可以简单的统一的处理包括头节点在内的所有节点
    根据上述分析,如何找到fast的位置,fast要找到与下一个元素不同的。
/**
 * Definition for singly-linked list.
 * public class ListNode {
 *     int val;
 *     ListNode next;
 *     ListNode(int x) { val = x; }
 * }
 */
class Solution {
    public ListNode deleteDuplicates(ListNode head) {
        ListNode dummy = new ListNode(-1); 取一个临时的节点指向head,方便后面删除head时候的处理
        dummy.next = head;
        // 找到删除的起点和终点
        ListNode slow = dummy;
        ListNode fast = dummy.next;
        while (fast != null) {
            // 找到下一个fast的位置,关键是fast.next.val != fast.val 同时注意,因为使用了fast.val 和fast.next.val 因此 fast 和 fast.next都不能为null
            while (fast != null && fast.next != null && fast.next.val == fast.val) {
                fast = fast.next;
            }
            if (slow.next != fast) { // fast和slow不相邻,说明中间有重复的元素
                slow.next = fast.next;
                fast = fast.next;
            } else { // fast和slow相邻,说明中间没有重复元素
                slow = slow.next;
                fast = fast.next;
            }
        }
        return dummy.next;     
    }
}

<LeetCode>双指针题目·

标签:ret   remove   统一   nod   class   使用   The   inpu   null   

原文地址:https://www.cnblogs.com/isguoqiang/p/11532255.html

(0)
(0)
   
举报
评论 一句话评论(0
登录后才能评论!
© 2014 mamicode.com 版权所有  联系我们:gaon5@hotmail.com
迷上了代码!